<template>
  <div v-if="!imgPokemon || !optionsPokemon.length" class="loading-container"><img src="../../../../public/assets/loading.gif"></div>
  <div v-else class="pokemon-container">
    <h2>Quien es este pokemon ?</h2>
    <img :src="imgPokemon" class="pokemon-image" >
    <ul v-if="responseSelectedState !== 'failed'" class="pokemon-options">
      <li v-for="pokemon in optionsPokemon" :key="pokemon.id" @click="selectedPokemon(pokemon)">
        {{ pokemon.name }}
      </li>
    </ul>
    <div v-if="responseSelectedState">
      <h3>{{ responseSelected }}</h3>
    </div>
    <div lass="score-container">
      <b>Puntaje:</b> {{ pointsUser }}
    </div>
    <div class="button-container">
      <button v-if="responseSelectedState === 'ok'" @click="continueGame" class="custom-button">Continuar</button>
      <button @click="endGame" class="custom-button">Finalizar</button>
    </div>
  </div>
</template>

<script>

import usePokemon from "@/composables/usePokemon";
import usePoints from "@/composables/usePoints";
import { onMounted, ref } from 'vue';
import { useRouter } from 'vue-router';

export default {
  setup() {

    const { pokemonInfo, pokemonsRandom, setSelectedPokemon } = usePokemon();
    const { savePoints, pointsUser, correoUser } = usePoints();
    const imgPokemon = ref('')
    const idPokemon = ref('')
    const namePokmeon = ref('')
    const responseSelected = ref('')
    const responseSelectedState = ref('')
    const optionsPokemon = ref([]) 
    const router = useRouter()

    const continueGame = async() => {

      imgPokemon.value = null
      optionsPokemon.value = []
      responseSelected.value = null
      responseSelectedState.value = null
      
      const { sprites, name, id } =  await pokemonInfo()
      imgPokemon.value = sprites.other['official-artwork']['front_default']
      idPokemon.value = id
      namePokmeon.value = name

      const data =  await pokemonsRandom()
      data.push({name, id})
      data.sort(() => Math.random() - 0.5)
      optionsPokemon.value = data
    }

    const endGame = async() => {

      await savePoints(pointsUser, correoUser);

      router.push({name: 'home'})
    }

    const selectedPokemon = async(pokemon) => {
      
      const {state, msg } = await setSelectedPokemon(pokemon, idPokemon, namePokmeon);
      
      responseSelected.value = msg
      responseSelectedState.value = state
    };

     onMounted( async() => {

        const { sprites, name, id } =  await pokemonInfo()
        imgPokemon.value = sprites.other['official-artwork']['front_default']
        idPokemon.value = id
        namePokmeon.value = name

        const data =  await pokemonsRandom()
        data.push({name, id});
        data.sort(() => Math.random() - 0.5)
        optionsPokemon.value = data
    })

    return{
        imgPokemon,
        continueGame,
        optionsPokemon,
        selectedPokemon,
        responseSelected,
        responseSelectedState, 
        endGame, 
        pointsUser 
    }
  }
}
</script>

<style scoped>
    @import url('../css/game.css');
</style>